// EditTerritories.cpp : implementation file
//

#include "stdafx.h"
#include "riskedit.h"
#include "EditTerritories.h"
#include "MapContinent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditTerritories dialog


CEditTerritories::CEditTerritories(CWnd* pParent /*=NULL*/)
	: CDialog(CEditTerritories::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditTerritories)
	//}}AFX_DATA_INIT
	m_pContinentName = 0;
	m_pMC = 0;	//pointer to map item for continent
	m_pMTend = 0;	//end of the teritory list
	m_pCurTer = 0;	//current selected territory
}

CEditTerritories::~CEditTerritories()
{
	if(m_pContinentName) delete [] m_pContinentName;
}


void CEditTerritories::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditTerritories)
	DDX_Control(pDX, IDC_EDIT_TERR_VALUE, m_Edit_Value);
	DDX_Control(pDX, IDC_LIST_TERR_LIST, m_ListBox_List);
	DDX_Control(pDX, IDC_EDIT_TERR_EDIT, m_Edit_Terr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditTerritories, CDialog)
	//{{AFX_MSG_MAP(CEditTerritories)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_TERR_DEL, OnButtonTerrDel)
	ON_BN_CLICKED(IDC_BUTTON_TERR_REPLACE, OnButtonTerrReplace)
	ON_LBN_SELCHANGE(IDC_LIST_TERR_LIST, OnSelchangeListTerrList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditTerritories message handlers

BOOL CEditTerritories::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	if(m_pContinentName)
	{
		char *s = new char[256];
		sprintf(s,"Territories For %s",m_pContinentName);
		SetWindowText(s);

		if(m_pMC->GetChild())
		{
			CMapTerritory *pMT = (CMapTerritory *)m_pMC->GetChild();
			while(pMT)
			{
				m_ListBox_List.AddString(pMT->GetName());
				pMT = (CMapTerritory *)pMT->GetNext();
			}
		}
		delete[] s;
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditTerritories::OnOK()
{
	// TODO: Add extra validation here

	CWnd *wC;
	char *s = new char[256];
	int v;

	wC = GetFocus();					//get handle of control that generated message
	int id = wC->GetDlgCtrlID();		//get ID of control
	switch(id)							//parse the id
	{
		case IDOK:
			CDialog::OnOK();
			break;
		case IDC_EDIT_TERR_VALUE:
			m_Edit_Value.GetWindowText(s,255);
			v = atoi(s);
			if(m_pCurTer)
				m_pCurTer->SetValue(v);
			break;
		case IDC_EDIT_TERR_EDIT:	//Add Territory
			m_Edit_Terr.GetWindowText(s,255);
			m_ListBox_List.AddString(s);
			m_Edit_Terr.SetWindowText("");
			m_Edit_Value.GetWindowText(s,255);
			v = atoi(s);
			m_Edit_Value.SetWindowText("");
			/******************************************
			 Add new territory to continet data element
			******************************************/
			if(m_pMC->GetChild() == NULL)	//first time thru?
			{
				CMapTerritory *pMT = new CMapTerritory();
				m_pMC->SetChild(pMT);	//create new territory
				pMT->SetName(s);
				pMT->SetValue(v);

			}
			else
			{
				//--------------------------------
				// OK, this is BOGUS!
				//--------------------------------
				if(m_pMTend == NULL)	//2nd time through?
				{
					m_pMTend = (CMapTerritory *)m_pMC->GetChild();
					while(m_pMTend->GetNext())
						m_pMTend = (CMapTerritory *)m_pMTend->GetNext();
				}
				CMapTerritory *pMT = new CMapTerritory();
				m_pMTend->SetNext(pMT);
				pMT->SetName(s);
				pMT->SetValue(v);
				m_pMTend = pMT;
			}
			break;
		default:
			wC = GetNextDlgTabItem(wC);	//reset the focus
			wC->SetFocus();
			break;
	}
	delete s;
}


void CEditTerritories::OnButtonAdd()
{
	// TODO: Add your control notification handler code here
	/************************************************
	** OnButtonAdd
	**
	** This function adds the territory name in the edit box to
	** the ListBox as well as the list of
	** Territories for this continent
	************************************************/
	char *s = new char[256];
	m_Edit_Terr.GetWindowText(s,255);
	m_ListBox_List.AddString(s);
	m_Edit_Terr.SetWindowText("");
	/******************************************
	 Add new territory to continet data element
	******************************************/
	if(m_pMC->GetChild() == NULL)	//first time thru?
	{
		CMapTerritory *pMT = new CMapTerritory();
		m_pMC->SetChild(pMT);	//create new territory
		pMT->SetName(s);

	}
	else
	{
		if(m_pMTend == NULL)	//2nd time through?
			m_pMTend = (CMapTerritory *)m_pMC->GetChild();
		CMapTerritory *pMT = new CMapTerritory();
		m_pMTend->SetNext(pMT);
		pMT->SetName(s);
		m_pMTend = pMT;
	}
	delete[] s;
}

void CEditTerritories::AddContinentName(char *s)
{
	m_pContinentName = new char[256];
	strcpy(m_pContinentName,s);
}

void CEditTerritories::OnButtonTerrDel()
{
	// TODO: Add your control notification handler code here
	/*************************************************
	** OnButtonTerrDel
	**
	** This function deletes the
	** Currently selected territory
	** from both the ListBox and from
	** the Territory list for htis
	** continent
	**************************************************/
	int sel;
	char *s = new char[256];
	CMapTerritory *pMT,*pMTList;

	sel = m_ListBox_List.GetCurSel();
	if(sel >= 0)
	{
		m_ListBox_List.GetText(sel,s);
		pMT = FindTerritory(s);	//locate name in data
		m_ListBox_List.DeleteString(sel);
		m_Edit_Terr.SetWindowText("");
		pMTList = (CMapTerritory *)m_pMC->GetChild();

		if(pMTList == pMT)	//first item in list?
		{
			pMT = (CMapTerritory *)pMT->GetNext();
			pMTList->SetNext(0);
			delete pMTList;
			m_pMC->SetChild(pMT);	//easy
		}
		else	//not firwst item in list
		{
			int loop = 1;
			while(pMTList && loop)
			{
				if(pMTList->GetNext())
				{
					if((CMapTerritory *)pMTList->GetNext() == pMT)
					{
						pMTList->SetNext(pMTList->GetNext()->GetNext());
						delete pMT;
						loop = 0;
					}
					else
						pMTList = (CMapTerritory *)pMTList->GetNext();
				}
				else
				{
					pMTList = (CMapTerritory *)pMTList->GetNext();
				}
			}
		}
	}
	delete[] s;
}

void CEditTerritories::OnButtonTerrReplace()
{
	// TODO: Add your control notification handler code here
	/****************************************
	** OnButtonTerrReplace
	**
	** This function is used to replace
	** The current selection in the ListBox
	** with the contents of Edit Box and then
	** to update the Territory data for that
	** element.
	****************************************/
}

CMapTerritory * CEditTerritories::FindTerritory(char *s)
{
	/****************************************
	** FindTeritory
	**
	** This function is used to find
	** a specific territory that is in the
	** list of territories for this
	** continent
	**
	**	parameter:
	**	s......name of territory to find
	**
	** Returns: NULL if not found
	**          Pointer to territory otherwise
	******************************************/
	CMapTerritory *pMT = (CMapTerritory *)m_pMC->GetChild();
	int loop = 1;
	while(pMT && loop)
	{
		if(strcmp(s,pMT->GetName()) == 0)
			loop = 0;
		else
			pMT = (CMapTerritory *)pMT->GetNext();
	}
	return pMT;
}

void CEditTerritories::OnSelchangeListTerrList()
{
	// TODO: Add your control notification handler code here
	/**************************************************************
	** OnSelchangeListTerrList
	**
	** When an item is selected in the listbox,
	** information concerning that item is copied
	** to the appropriate edit controls
	**************************************************************/
	int sel;
	char *s = new char[256];
	sel = m_ListBox_List.GetCurSel();
	m_ListBox_List.GetText(sel,s);
	m_Edit_Terr.SetWindowText(s);
	CMapTerritory *pMT = FindTerritory(s);
	sprintf(s,"%d",pMT->GetValue());
	m_Edit_Value.SetWindowText(s);
	m_pCurTer = pMT;
	delete[] s;
}
