// RiskEditView.cpp : implementation of the CRiskEditView class
//

#include "stdafx.h"
#include "RiskEdit.h"

#include "AutoScrollView.h"
#include "RiskEditDoc.h"
#include "MainFrm.h"
#include "RiskEditView.h"
#include "EditContinents.h"
#include "DlgMeridianLogitude.h"
#include "SelectTerritory.h"
#include "EditAdjacetTerr.h"
#include "RiskUtils.h"
#include "MapInfoDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRiskEditView

IMPLEMENT_DYNCREATE(CRiskEditView, CAutoScrollView)

BEGIN_MESSAGE_MAP(CRiskEditView, CAutoScrollView)
	//{{AFX_MSG_MAP(CRiskEditView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(IDM_EDIT_CONTINENT, OnEditContinent)
	ON_COMMAND(IDM_EDIT_MERIDIANS, OnEditMeridians)
	ON_COMMAND(IDM_EDIT_DEBUG, OnEditDebug)
	ON_COMMAND(IDM_EDIT_COLOR, OnEditColor)
	ON_COMMAND(IDT_DRAW, OnDrawTool)
	ON_COMMAND(IDT_FILL, OnFillTool)
	ON_COMMAND(IDT_ERASE, OnErase)
	ON_COMMAND(IDT_BORDERS_TOOL, OnBordersTool)
	ON_COMMAND(ID_BUTTON_POLYGON, OnButtonPolygon)
	ON_WM_TIMER()
	ON_COMMAND(IDM_VIEW_POLYGONS, OnViewPolygons)
	ON_COMMAND(ID_BUTTON_ASSIGN, OnButtonAssign)
	ON_COMMAND(ID_BUTTON_CONNECT, OnButtonConnect)
	ON_COMMAND(IDT_LARGEDOT, OnLargedot)
	ON_COMMAND(IDT_MEDIUMDOT, OnMediumdot)
	ON_COMMAND(IDT_SMALLDOT, OnSmalldot)
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(ID_ONE_GETCOLOR, OnUpdateOneGetcolor)
	ON_UPDATE_COMMAND_UI(ID_ONE_DEL_POLY, OnUpdateOneDelPoly)
	ON_UPDATE_COMMAND_UI(ID_ONE_ASSIGN, OnUpdateOneAssign)
	ON_UPDATE_COMMAND_UI(ID_ONE_LINK_TERR, OnUpdateOneLinkTerr)
	ON_WM_CANCELMODE()
	ON_COMMAND(ID_MENU_VIEW_AUTOSCROLL, OnMenuViewAutoscroll)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_SIZE()
	ON_COMMAND(ID_MENU_INFO_STATS, OnMenuInfoStats)
	ON_COMMAND(ID_MENU_EDIT_UDATECOLORS, OnMenuEditUdatecolors)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CAutoScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CAutoScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CAutoScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRiskEditView construction/destruction

CRiskEditView::CRiskEditView()
{
	// TODO: add construction code here

	m_MouseDown = 0;
	m_EraseBKG = 0;
	m_Unget_Buffer = 0;
	m_pLexBuff = new char[256];
	m_CurColor = RGB(0,0,255);
	m_BorderColor = RGB(0,0,0);
	m_BkgColor = RGB(255,255,255);
	m_pFileName = NULL;
	m_pBMfileName = NULL;
	m_pPathName = NULL;
	m_LineEraseFlag = 0;
	m_Timer_MB_RightFlag = 0;
	m_Timer_MB_LeftFlag = 0;
	m_PolyView = 1;
	m_DrawPenSize = 1;
	m_AutoScrollMode = 0;
	m_TimerScroll = 1;
	pDB = 0;
}

CRiskEditView::~CRiskEditView()
{
	delete[] m_pLexBuff;
	if(m_pFileName) delete[] m_pFileName;
	if(m_pBMfileName) delete[] m_pBMfileName;
	if(m_pPathName) delete[] m_pPathName;
	if(pDB) fclose(pDB);
}

BOOL CRiskEditView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CAutoScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CRiskEditView drawing

void CRiskEditView::OnDraw(CDC* pDC)
{
	CRiskEditDoc* pDoc = GetDocument();
//	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	CRect ClientRect;
	CPolygon *pP;
	GetClientRect(&ClientRect);
	pDC->BitBlt(0,0,3600,2250,&m_MemDC,0,0,SRCCOPY);
	if(m_CurTool == TOOL_POLYGON)
	{
		CPen Pen,*pOldPen;
		Pen.CreatePen(PS_SOLID,1,RGB(255,0,0));
		pOldPen = pDC->SelectObject(&Pen);
		if(m_LineRubberband)
		{
			pDC->MoveTo(m_LineStart);
			pDC->LineTo(m_LineEnd);
		}
		if(m_scrPoly.GetCount() > 1)
		{
			DrawPolyLine(pDC,&m_scrPoly);
//			DrawPoly(pDC,&m_scrPoly);
		}
		pDC->SelectObject(pOldPen);
	}
	if(m_PolyView && (pP = pDoc->m_pPolyList))
	{
		while(pP)
		{
			DrawPoly(pDC,pP);
			pP = pP->GetNext();
		}
	}


}

void CRiskEditView::OnInitialUpdate()
{

	CAutoScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	CRiskEditDoc *pDoc = GetDocument();
	CDC *pDC = GetDC();
	m_MemDC.CreateCompatibleDC(pDC);
	if(pDoc->m_DoLoad)
	{
		OnFileOpen();
	}
	if(pDoc->m_pMapData)
	{
		sizeTotal.cx =pDoc->m_pMapData->GetMapWidth();
		sizeTotal.cy = pDoc->m_pMapData->GetMapHieght();
	}
	else
	{
		sizeTotal.cx = 3600;
		sizeTotal.cy = 2250;
	}
	SetScrollSizes(MM_TEXT, sizeTotal);
	m_EraseBKG = 1;
	m_CurrentPen.CreatePen(0,1,m_CurColor);
	m_MemDC.SelectObject(pDoc->m_pMAP);
	ReleaseDC(pDC);
	Invalidate();
//	pDB = fopen("Log.txt","w");
}

/////////////////////////////////////////////////////////////////////////////
// CRiskEditView printing

BOOL CRiskEditView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CRiskEditView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CRiskEditView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CRiskEditView diagnostics

#ifdef _DEBUG
void CRiskEditView::AssertValid() const
{
	CAutoScrollView::AssertValid();
}

void CRiskEditView::Dump(CDumpContext& dc) const
{
	CAutoScrollView::Dump(dc);
}

CRiskEditDoc* CRiskEditView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRiskEditDoc)));
	return (CRiskEditDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRiskEditView message handlers

void CRiskEditView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	/******************************************************
	** OnLButtonDown
	**
	** This function lets us know when
	** the left button on the mouse has been
	** pushed down.
	**
	** parameters:
	**	nFlags....various status at time of clocl
	**	point.....where the click occured.
	******************************************************/

	CPoint pos = point;
	CBrush *pOld,*pB;
	m_MouseDown = 1;
	CClientDC DC(this);

	CAutoScrollView::OnPrepareDC(&DC);
	DC.DPtoLP(&pos);
	m_LastPoint = pos;
	m_MouseDownPoint = pos;
	switch(this->m_CurTool)
	{
		case TOOL_DRAW:
			m_MemDC.SetPixel(pos,this->m_CurColor);
			this->Invalidate();
			break;
		case TOOL_FILL:
			pB = new CBrush;
			pB->CreateSolidBrush(m_CurColor);
			pOld = m_MemDC.SelectObject(pB);
			m_MemDC.ExtFloodFill(pos.x,pos.y,m_BorderColor,FLOODFILLBORDER);
			m_MemDC.SelectObject(pOld);
			this->Invalidate();
			break;
		case TOOL_ERASE:
			m_MemDC.SetPixel(pos,this->m_BkgColor);
			this->Invalidate();
			break;
		case TOOL_BORDER:
			m_MemDC.SetPixel(pos,this->m_BorderColor);
			break;
		case TOOL_POLYGON:
			if(pDB)fprintf(pDB,"Mouse Down:State=%d\n",m_PolyState);
			if(m_PolyState == 0)
			{
				m_LineRubberband = 0;
				m_LineStart = pos;
				m_LineEnd = pos;
				m_PolyState = 1;
			}
			else if(m_PolyState == 4)
			{
				m_LineRubberband = 0;
				m_LineStart = m_LineEnd;
				m_LineEnd = pos;
				m_PolyState = 5;
			}
			break;
		case TOOL_ASSING:
			if(!AssignTerrToPoly(pos))
				MessageBox("No Polygon Found","Whoopsie",MB_ICONHAND | MB_OK);
			else
				Invalidate();
			break;
	}
	CAutoScrollView::OnLButtonDown(nFlags, point);
}

void CRiskEditView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	if(pDB) fprintf(pDB,"Mouse UP\n");
	if(this->m_Timer_MB_LeftFlag == 0)
	{
//		m_Timer_MB_LeftFlag = 1;
//		SetTimer(TIMEREVENT_LMB,50,NULL);
		CPoint pos = point;
		m_MouseDown = 0;
		CClientDC DC(this);
		CAutoScrollView::OnPrepareDC(&DC);
		DC.DPtoLP(&pos);
		switch(m_CurTool)
		{
			case TOOL_POLYGON:
				if(m_MouseDownPoint != pos)
				{
					if(m_PolyState == 2)
					{
						m_LineRubberband = 0;
						m_PolyState = 4;
						m_scrPoly.AddPoint(m_MouseDownPoint);
						m_scrPoly.AddPoint(pos);
					}
					else if(m_PolyState == 6)
					{
						m_LineRubberband = 0;
						m_PolyState = 4;
						m_scrPoly.AddPoint(pos);
					}
				}
				else
				{	//points are same, start over
						m_LineRubberband = 0;
						m_PolyState = 1;
				}
				break;
		}
	}
	CAutoScrollView::OnLButtonUp(nFlags, point);
}

void CRiskEditView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	/*************************************
	** OnMouseMove
	**
	** This function is called when
	** the mouse is moved over the document
	** area.  Depending on what we are
	** trying to do,this function uses the
	** mouse movement to alther the display
	**
	** parameter:
	**	nFlags.....tells us various status
	**	point......where the mouse is
	****************************************/
	CPen *pOldPen;
	CPen Pen;
	CPoint pos;		//modified position

	CClientDC DC(this);
	CAutoScrollView::OnPrepareDC(&DC);
	pos = point;
	DC.DPtoLP(&pos);

	if(pDB) fprintf(pDB,"Mouse Move:MDFlag=%d\n",m_MouseDown);

	if(m_MouseDown)
	{
		switch(this->m_CurTool)
		{
			case TOOL_DRAW:
				Pen.CreatePen(PS_SOLID,m_DrawPenSize,this->m_CurColor);
				pOldPen = m_MemDC.SelectObject(&Pen);
				m_MemDC.MoveTo(m_LastPoint);
				m_MemDC.LineTo(pos);
				m_LastPoint = pos;
				m_MemDC.SelectObject(pOldPen);
				break;
			case TOOL_FILL:
				break;
			case TOOL_ERASE:
				Pen.CreatePen(PS_SOLID,m_DrawPenSize,this->m_BkgColor);
				pOldPen = m_MemDC.SelectObject(&Pen);
				m_MemDC.MoveTo(m_LastPoint);
				m_MemDC.LineTo(pos);
				m_LastPoint = pos;
				m_MemDC.SelectObject(pOldPen);
				break;
			case TOOL_BORDER:
				Pen.CreatePen(PS_SOLID,1,this->m_BorderColor);
				pOldPen = m_MemDC.SelectObject(&Pen);
				m_MemDC.MoveTo(m_LastPoint);
				m_MemDC.LineTo(pos);
				m_LastPoint = pos;
				m_MemDC.SelectObject(pOldPen);
				break;
			case TOOL_POLYGON:
				if(pDB) fprintf(pDB,"Mouse Move:State=%d\n",m_PolyState);
				if((this->m_PolyState == 1) || (m_PolyState == 2))
				{
					m_LineRubberband = 1;
					m_PolyState = 2;
					m_LineEnd = pos;
				}
				else if((this->m_PolyState == 5) || (m_PolyState == 6))
				{
					m_LineRubberband = 1;
					m_PolyState = 6;
					m_LineEnd = pos;
				}
				break;
		}
		this->Invalidate();
	}
	CAutoScrollView::OnMouseMove(nFlags, point);

}

void CRiskEditView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	// TODO: Add your message handler code here
	int idm;
	CPoint pos = point;
	ScreenToClient(&pos);
	CRiskEditDoc *pDoc;
	CClientDC DC(this);
	CAutoScrollView::OnPrepareDC(&DC);
	DC.DPtoLP(&pos);

	CMenu menu;
	menu.LoadMenu (IDR_MENU1);
	CMenu* pContextMenu = menu.GetSubMenu (0);
	idm = pContextMenu->TrackPopupMenu(TPM_RETURNCMD | TPM_LEFTALIGN | TPM_LEFTBUTTON,point.x, point.y,AfxGetMainWnd());
	switch(idm)
	{
		case ID_ONE_ENDPOLYGON:
			if(pDB) fprintf(pDB,"End PolyGon:State=%d\n",m_PolyState);
			if(m_PolyState)
			{
				m_PolyState = 0;
				pDoc = GetDocument();
				pDoc->AddPolygon(&m_scrPoly);
				m_scrPoly.Reset();
				m_scrPoly.SetSelected(1);
				Invalidate();
			}
			break;
		case ID_ONE_SELECTPOLYGON:
			{
				CPolygon *pPol;
				pDoc = GetDocument();
				pPol = pDoc->m_pPolyList;
				pPol = PointInWhichPolygon(pPol,pos);
				if(pPol)
				{
					int sel = pPol->GetSelected() + 1;
					if(sel == 3) sel = 0;
					pPol->SetSelected(sel);
				}
				Invalidate();
			}
			break;
		case ID_ONE_GETCOLOR:
			pDoc = GetDocument();
			this->m_CurColor = m_MemDC.GetPixel(pos);
			break;
		case ID_ONE_DEL_POLY:
			{
				CPolygon *pPol;
				pDoc = GetDocument();
				pPol = pDoc->m_pPolyList;
				pPol = PointInWhichPolygon(pPol,pos);
				if(pPol)
				{
					pDoc->DeletePolygon(pPol);
				}
				Invalidate();
			}
			break;
		case IDM_EDIT_COLOR:
			OnEditColor();
			break;
		case ID_ONE_ASSIGN:
			if(!AssignTerrToPoly(pos))
				MessageBox("No Polygon Found","Whoopsie",MB_ICONHAND | MB_OK);
			else
				Invalidate();
			break;
		case ID_ONE_LINK_TERR:
			{
				pDoc = GetDocument();
				CMapContinent *pMC;
				pMC = PointInWhichContinent(pDoc->m_pMapData,pDoc->m_pPolyList,pos);
				CMapTerritory *pMT;
				pMT = PointInWhichTerritory(pDoc->m_pMapData,pDoc->m_pPolyList,pos);
				CEditAdjacetTerr Dlg;
				Dlg.m_pMC_Init = pMC;
				Dlg.m_pMT_Init = pMT;
				CRiskEditDoc *pDoc = GetDocument();
				Dlg.m_pMap = pDoc->m_pMapData;
				Dlg.DoModal();
			}
			break;
	}
	CWnd::OnContextMenu(pWnd,point);
}

BOOL CRiskEditView::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Add your message handler code here and/or call default
	/****************************************
	** OnEraseBkgnd
	** This function is called before
	** OnDraw.  If the flag m_EraseBKG
	** is true, we erase the background.
	** The flag is reset to 0 on exit.
	** The flag needs to be set before
	** an OnDraw is executed if there is
	** Junk in the veiw that needs to be
	** obliterated.  Normally, the
	** display is not erased to keep
	** flickering down to a minimum.
	*******************************************/
	BOOL rV = 1;
	if(m_EraseBKG)
	{
		rV = CAutoScrollView::OnEraseBkgnd(pDC);
		m_EraseBKG = 0;
	}
	return rV ;
}

void CRiskEditView::OnFileSave()
{
	// TODO: Add your command handler code here
	char *s;
	s = GenMapDataName();
	FILE *pO = fopen(s,"w");
	CRiskEditDoc *pDoc = GetDocument();
	pDoc->m_pMapData->PrintAll(pO);
	pDoc->SavePolygons(pO);
	fclose(pO);
	delete[] s;
	s = GenBitMapName();
	pO = fopen(s,"wb");
	pDoc->SaveBitmap(pO);
	fclose(pO);
	delete[] s;
}

void CRiskEditView::OnFileSaveAs()
{
	// TODO: Add your command handler code here
	CFileDialog Dlg(FALSE,"map","*.map",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,NULL,this);
	int id;

	id = Dlg.DoModal();
	if(id == IDOK)
	{
		CString path;
		char *pn;
		char *s;
		path = Dlg.GetPathName();
		pn = path.GetBuffer(256);
		ProcesFileName(pn);
		s = GenMapDataName();
		FILE *pO = fopen(s,"w");
		CRiskEditDoc *pDoc = GetDocument();
		pDoc->m_pMapData->PrintAll(pO);
		pDoc->SavePolygons(pO);
		fclose(pO);
		delete[] s;
		s = GenBitMapName();
		pO = fopen(s,"wb");
		pDoc->SaveBitmap(pO);
		fclose(pO);
		delete[] s;
	}
}

void CRiskEditView::OnFileOpen()
{
	// TODO: Add your command handler code here
	/****************************************
	** OnFileOpen
	**
	** This function is called in response to
	** the OPEN menue item being clicked
	** int the file menu.  This is used
	** for loading a saved map.
	*****************************************/

	CFileDialog Dlg(TRUE,"map","*.map",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,NULL,this);
	Dlg.DoModal();
	CString nm = Dlg.GetPathName();
	char *name = nm.GetBuffer(256);
	ProcesFileName(name);
	FILE *pI = fopen(name,"r");
	nm.ReleaseBuffer();
	if(pI)
	{
		m_Line = 0;
		CMap *pM = Parser(pI);
		CRiskEditDoc *pDoc = GetDocument();
		pDoc->m_pMapData = pM;
		char *s = new char[256];
		sprintf(s,"%s\\%s",m_pPathName,m_pBMfileName);
		pDoc->m_pMAP->LoadBitmap(s);
		m_MemDC.SelectObject(pDoc->m_pMAP);
		delete[] s;
//		Invalidate();
	}
}

void CRiskEditView::ProcesFileName(char *name)
{
	//allocate mem, if needed for path
	if(m_pPathName == NULL) m_pPathName = new char[256];
	strcpy(m_pPathName,name);
	//find the last '\' character in name
	char *pC = strrchr(m_pPathName,'\\');
	//nulling this out, gives just the path
	if(pC)*pC = 0;
	//allocate memory, if needed, for map data file name
	if(m_pFileName == NULL) m_pFileName = new char[256];
	//find last '\' again
	pC = strrchr(name,'\\');
	if(pC) ++pC;	//point to name
	strcpy(m_pFileName,pC);	//copy into file name
	//allocate memory, if needed, for bitmap file name
	if(m_pBMfileName == NULL) m_pBMfileName = new char[256];
	strcpy(m_pBMfileName,m_pFileName);
	//locate last '.' to find extension
	pC = strrchr(m_pBMfileName,'.');
	if(pC)
	{
		//turn extension into bmp
		++pC;
		*pC = 0;
		strcat(m_pBMfileName,"bmp");
	}
}

char * CRiskEditView::GenMapDataName()
{
	char *s = new char[256];
	sprintf(s,"%s\\%s",m_pPathName,m_pFileName);
	return s;
}

char * CRiskEditView::GenBitMapName()
{
	char *s = new char[256];
	sprintf(s,"%s\\%s",m_pPathName,m_pBMfileName);
	return s;
}

CMap * CRiskEditView::LoadMapData(FILE *pI)
{
	CMap *pMap = 0;
	return pMap;
}

//******************************************
//** Token defines for file reading parser
//******************************************

#define TOKEN_STRING	256
#define TOKEN_NUM		257
#define TOKEN_MAP		258
#define TOKEN_CONTINENT	259
#define TOKEN_TERRITORY	260
#define TOKEN_MERIDIAN	261
#define TOKEN_LONGITUDE	262
#define TOKEN_WIDTH		263
#define TOKEN_SPACING	264
#define TOKEN_START		265
#define TOKEN_END		266
#define TOKEN_RGB		267
#define TOKEN_HEIGHT	268
#define TOKEN_BORDER	269
#define TOKEN_COLOR		270
#define TOKEN_EOF		271
#define TOKEN_VALUE		272
#define TOKEN_LOCATION	273
#define TOKEN_POLYGON	274
#define TOKEN_ATTACHED	275
#define TOKEN_ADJ		276

//--------------
// keywords
//--------------

typedef struct {
	const char *pName;
	int tokenval;
}KEYWORD;

KEYWORD Keywords[] = {
	{"MAP",TOKEN_MAP},
	{"CONTINENT",TOKEN_CONTINENT},
	{"TERRITORY",TOKEN_TERRITORY},
	{"MERIDIAN",TOKEN_MERIDIAN},
	{"LONGITUDE",TOKEN_LONGITUDE},
	{"SPACING",TOKEN_SPACING},
	{"WIDTH",TOKEN_WIDTH},
	{"START",TOKEN_START},
	{"END",TOKEN_END},
	{"RGB",TOKEN_RGB},
	{"HEIGHT",TOKEN_HEIGHT},
	{"BORDER",TOKEN_BORDER},
	{"COLOR",TOKEN_COLOR},
	{"VALUE",TOKEN_VALUE},
	{"LOCATION",TOKEN_LOCATION},
	{"POLYGON",TOKEN_POLYGON},
	{"ATTACHED",TOKEN_ATTACHED},
	{"ADJ",TOKEN_ADJ},
	{NULL,-1}
};

int CRiskEditView::Lookup(char *s)
{
	/************************************************
	** Lookup
	**
	** This function is used to check a string
	** against a list of keywords for the
	** Risk File Format.
	**
	** Parameter:
	**	s......string to check against keywords
	**
	** Returns:TOKEN VALUE if it is a keyword
	**
	***********************************************/
	int i;
	int loop = 1;
	int rV=0;

	for(i=0;Keywords[i].pName && loop ;++i)
	{
		if(strcmp(s,Keywords[i].pName)==0)
		{
			rV = Keywords[i].tokenval;
			loop = 0;
		}
	}
	return rV;
}

int CRiskEditView::Lexer(FILE *pI)
{
	/***********************************************
	** Lexer
	** This is the Lexer function for breaking
	** up the input stream for a map data file
	** into a series of tokens.
	**
	** parameter:
	**	pI.... pointer to the input stream
	** Returns: A token representing a specific
	** series of characters
	************************************************/
	int c;
	int loop = 1;
	int rV;
	int i;
	int stringflag;

	while(loop)
	{
		c = GetChar(pI);
		switch(c)
		{
			case EOF:
				rV = TOKEN_EOF;
				loop = 0;
				break;
			case ' ':
			case '\t':
				break;
			case '\n':
				++m_Line;
				break;
			case '\r':
				break;
			case '}':
			case '{':
			case ':':
			case ',':
			case '(':
			case ')':
			case '[':
			case ']':
				rV = c;
				loop = 0;
				break;
			case '0':	case '1':	case '2':	case '3':
			case '4':	case '5':	case '6':	case '7':
			case '8':	case '9':	case '-':
				i = 0;
				m_pLexBuff[i++] = c;
				while(isdigit(c = GetChar(pI)) )
					m_pLexBuff[i++] = c;
				m_Unget_Buffer = c;	//unget character
				m_pLexBuff[i] = 0;
				m_TokenValue = atoi(m_pLexBuff);
				rV = TOKEN_NUM;
				loop = 0;
				break;
			case '"':	//string that includes spaces
				i = 0;
				c = GetChar(pI);
				m_pLexBuff[i++] = c;
				stringflag = 1;
				while(stringflag )
				{
					c = GetChar(pI);
					if(c == '"')
						stringflag = 0;
					else
						m_pLexBuff[i++] = c;
				}
				m_pLexBuff[i] = 0;
				rV = TOKEN_STRING;
				loop = 0;
				break;
			default:	//strings and keywords
				i = 0;
				m_pLexBuff[i++] = c;
				stringflag = 1;
				while(stringflag )
				{
					c = GetChar(pI);
					if(isalpha(c))
						m_pLexBuff[i++] = c;
					else
						stringflag = 0;
				}
				m_Unget_Buffer = c;
				m_pLexBuff[i] = 0;
				if((rV = Lookup(m_pLexBuff))>0)
					loop = 0;
				else
				{
					rV = TOKEN_STRING;
					loop = 0;
				}
				break;
		}
	}
	return rV;
}

CMap *CRiskEditView::Parser(FILE *pI)
{
	/********************************************
	** Parser
	**
	** This is the parser for loading in
	** RISK map data.
	**
	** parameter:
	**	pI......pointer to the input stram
	**
	** Returns a pointer to a MAP object
	********************************************/
	CMap *pMap;
	CMapContinent *pMC;
	CPolygon *pPoly;
	unsigned R,G,B;
	CRiskEditDoc *pDoc = GetDocument();
	int rV = 0;
	int loop;

	loop = 1;
	m_LookAHead = Lexer(pI);
	while(loop)
	{
		switch(m_LookAHead)
		{
			case TOKEN_MAP:
				pMap = new CMap;
				m_LookAHead = match(pI,TOKEN_MAP);
				m_LookAHead = match(pI,':');
				m_LookAHead = match(pI,':');
				if(m_LookAHead == TOKEN_STRING)
					pMap->SetName(m_pLexBuff);
				else
					Error("Expected String");
				m_LookAHead = match(pI,TOKEN_STRING);
				break;
			case TOKEN_LONGITUDE:
				m_LookAHead = match(pI,TOKEN_LONGITUDE);
				switch(m_LookAHead)
				{
					case TOKEN_WIDTH:
						m_LookAHead = match(pI,TOKEN_WIDTH);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetLogLineWidth(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
					case TOKEN_SPACING:
						m_LookAHead = match(pI,TOKEN_SPACING);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetLogSpacing(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
					case TOKEN_START:
						m_LookAHead = match(pI,TOKEN_START);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetLogStart(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
					case TOKEN_END:
						m_LookAHead = match(pI,TOKEN_END);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetLogEnd(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
				}
				break;
			case TOKEN_MERIDIAN:
				m_LookAHead = match(pI,TOKEN_MERIDIAN);
				switch(m_LookAHead)
				{
					case TOKEN_WIDTH:
						m_LookAHead = match(pI,TOKEN_WIDTH);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetMerLineWidth(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
					case TOKEN_SPACING:
						m_LookAHead = match(pI,TOKEN_SPACING);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetMerSpacing(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
					case TOKEN_START:
						m_LookAHead = match(pI,TOKEN_START);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetMerStart(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
					case TOKEN_END:
						m_LookAHead = match(pI,TOKEN_END);
						m_LookAHead = match(pI,'(');
						if(Expect(TOKEN_NUM,m_LookAHead))
							pMap->SetMerEnd(m_TokenValue);
						m_LookAHead = match(pI,TOKEN_NUM);
						m_LookAHead = match(pI,')');
						break;
				}
				break;
			case TOKEN_WIDTH:
				m_LookAHead = match(pI,TOKEN_WIDTH);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
					pMap->SetMapWidth(m_TokenValue);
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,')');
				break;
			case TOKEN_HEIGHT:
				m_LookAHead = match(pI,TOKEN_HEIGHT);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
					pMap->SetMapHieght(m_TokenValue);
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,')');
				break;
			case TOKEN_BORDER:
				m_LookAHead = match(pI,TOKEN_BORDER);
				m_LookAHead = match(pI,TOKEN_COLOR);
				m_LookAHead = match(pI,'(');
				m_LookAHead = match(pI,TOKEN_RGB);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
				{
					R = atoi(this->m_pLexBuff);
					m_LookAHead = match(pI,TOKEN_NUM);
				}
				m_LookAHead = match(pI,',');
				if(Expect(TOKEN_NUM,m_LookAHead))
				{
					G = atoi(this->m_pLexBuff);
					m_LookAHead = match(pI,TOKEN_NUM);
				}
				m_LookAHead = match(pI,',');
				if(Expect(TOKEN_NUM,m_LookAHead))
				{
					B = atoi(this->m_pLexBuff);
					m_LookAHead = match(pI,TOKEN_NUM);
				}
				pMap->SetBorderColor(R<<16 | G << 8 | B);
				m_LookAHead = match(pI,')');
				m_LookAHead = match(pI,')');
				break;
			case '{':
				m_LookAHead = match(pI,'{');
				switch(m_LookAHead)
				{
					case TOKEN_CONTINENT:
						pMC = ParseContinent(pI);
						pMap->SetChild(pMC);
						break;
				}
				m_LookAHead = match(pI,'}');
				break;
			case TOKEN_POLYGON:
					pPoly = ParsePolygon(pI,pMap);
					pDoc->AddPolygon(pPoly);
					delete pPoly;
					break;
			case TOKEN_EOF:
				loop = 0;
				break;
		}
	}	//end of while 1 loop
	Compile(pMap);
	return pMap;
}


CPolygon * CRiskEditView::ParsePolygon(FILE *pI,CMap *pM)
{
	CPolygon *pPoly = new CPolygon;
	CMapTerritory *pT;
	int X,Y;
	int loop = 1;

	m_LookAHead = match(pI,TOKEN_POLYGON);
	m_LookAHead = match(pI,':');
	m_LookAHead = match(pI,':');
	if(m_LookAHead == '(' )	//polygon has ID
	{
		m_LookAHead = match(pI,'(');
		pT = FindTerritory(pM,this->m_pLexBuff);
		pPoly->SetTerritory(pT);
		m_LookAHead = match(pI,TOKEN_STRING);
		m_LookAHead = match(pI,')');
	}
	m_LookAHead = match(pI,'[');
	while(loop)
	{
		switch(m_LookAHead)
		{
			case ']':
				loop = 0;
				m_LookAHead = match(pI,']');
				break;
			case '(':
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
					X = this->m_TokenValue;
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,',');
				if(Expect(TOKEN_NUM,m_LookAHead))
					Y = this->m_TokenValue;
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,')');
				pPoly->AddPoint(CPoint(X,Y));
				break;
		}
	}
	return pPoly;
}

CMapContinent * CRiskEditView::ParseContinent(FILE *pI)
{
	/********************************************
	** ParseContinent
	**
	** this function parses the tokens for
	** a Continent data structure.
	**
	** parameter:
	**	pI....pointer to input stream
	**
	** Returns
	**		Pointer to a list of contiments
	********************************************/

	CMapContinent *pMC=0,*pMCList=0,*pMCend;
	CMapTerritory *pMT;
	int loop;

	loop = 1;
	while(loop)
	{
		switch(m_LookAHead)
		{
			case TOKEN_CONTINENT:
				pMC = new CMapContinent;
				m_LookAHead = match(pI,TOKEN_CONTINENT);
				m_LookAHead = match(pI,':');
				m_LookAHead = match(pI,':');
				if(m_LookAHead == TOKEN_STRING)
					pMC->SetName(m_pLexBuff);
				else
					Error("Expected String");
				m_LookAHead = match(pI,TOKEN_STRING);
				//--------------------------
				// Make continent list
				//--------------------------
				if(pMCList == 0)
				{
					pMCList = pMC;
					pMCend = pMC;
				}
				else
				{
					pMCend->SetNext(pMC);
					pMCend = pMC;
				}
				break;
			case TOKEN_VALUE:
				m_LookAHead = match(pI,TOKEN_VALUE);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
					pMC->SetValue(m_TokenValue);
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,')');
				break;
			case '{':
				m_LookAHead = match(pI,'{');
				switch(m_LookAHead)
				{
					case TOKEN_TERRITORY:
						pMT = ParseTerritory(pI);
						pMC->SetChild(pMT);
						m_LookAHead = match(pI,'}');
						break;
				}
				break;
			case '}':
				loop = 0;
				break;
		}	//end of switch(lookahead)
	}	//end of while(loop);
	return pMCList;
}

CMapTerritory * CRiskEditView::ParseTerritory(FILE *pI)
{
	/*******************************************
	** ParseTerritory
	** This function parses tokens for a Territory
	** Data structure
	**
	** parameter:
	**	pI.....pointer to input stream
	**
	** Returns:pointer to list of territories
	*********************************************/
	CMapTerritory *pMT = 0,*pMTList=0,*pMTend;
	int xLoc,yLoc;
	int loop;
	int r,g,b;

	loop = 1;
	while(loop)
	{
		switch(m_LookAHead)
		{
			case TOKEN_TERRITORY:
				pMT = new CMapTerritory();
				m_LookAHead = match(pI,TOKEN_TERRITORY);
				m_LookAHead = match(pI,':');
				m_LookAHead = match(pI,':');
				if(m_LookAHead == TOKEN_STRING)
					pMT->SetName(m_pLexBuff);
				else
					Error("Expected String");
				m_LookAHead = match(pI,TOKEN_STRING);
				//------------------------
				// make territory list
				//------------------------
				if(pMTList == 0)
				{
					pMTList = pMT;
					pMTend = pMT;
				}
				else
				{
					pMTend->SetNext(pMT);
					pMTend = pMT;
				}
				break;
			case TOKEN_LOCATION:
				m_LookAHead = match(pI,TOKEN_LOCATION);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
					xLoc = m_TokenValue;
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,',');
				if(Expect(TOKEN_NUM,m_LookAHead))
					yLoc = m_TokenValue;
				pMT->SetLocation(xLoc,yLoc);
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,')');
				break;
			case TOKEN_VALUE:
				m_LookAHead = match(pI,TOKEN_VALUE);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead))
					pMT->SetValue(m_TokenValue);
				m_LookAHead = match(pI,TOKEN_NUM);
				m_LookAHead = match(pI,')');
				break;
			case TOKEN_ADJ:	//adjacent terrotry list
				m_LookAHead = match(pI,TOKEN_ADJ);
				m_LookAHead = match(pI,'[');
				while(TOKEN_STRING==m_LookAHead)
				{
					//---------------------------------
					// OK, we have a problem here
					// we need to add neighbors that
					// just don't exist.  So, we
					// will just use the name, and
					// then when done, we do a compile
					//---------------------------------
					CTerrList *pL = new CTerrList;
					pL->SetName(m_pLexBuff);
					pMT->AddNieghbor(pL);
					m_LookAHead = match(pI,TOKEN_STRING);
					if(m_LookAHead == ',')
						m_LookAHead = match(pI,',');
				}
				m_LookAHead = match(pI,']');
				break;
			case TOKEN_COLOR:
				m_LookAHead = match(pI,TOKEN_COLOR);
				m_LookAHead = match(pI,'(');
				m_LookAHead = match(pI,TOKEN_RGB);
				m_LookAHead = match(pI,'(');
				if(Expect(TOKEN_NUM,m_LookAHead) )
				{
					r = m_TokenValue;
					m_LookAHead = match(pI,TOKEN_NUM);
				}
				m_LookAHead = match(pI,',');
				if(Expect(TOKEN_NUM,m_LookAHead) )
				{
					g = m_TokenValue;
					m_LookAHead = match(pI,TOKEN_NUM);
				}
				m_LookAHead = match(pI,',');
				if(Expect(TOKEN_NUM,m_LookAHead) )
				{
					b = m_TokenValue;
					m_LookAHead = match(pI,TOKEN_NUM);
				}
				m_LookAHead = match(pI,')');
				m_LookAHead = match(pI,')');
				pMT->SetColor(RGB(r,g,b));
				break;
			case '{':	//childeren of Territory
				break;
			case '}':
				loop = 0;
				break;
		}//end of switch(lookahead)
	}	//end of while(loop)

	return pMTList;
}

int CRiskEditView::Expect(int Tv,int LookAHead)
{
	int rV=0;

	if(Tv == LookAHead)
		rV = 1;
	else
	{
		char *s = new char[256];
		sprintf(s,"Expected %d  Got %d",Tv,LookAHead);
		Error(s);
		delete [] s;
	}
	return rV;
}

int CRiskEditView::match(FILE *pI, int token)
{
	/********************************************
	** match
	**
	** this function is used to match
	** the expected token with the current
	** token.  If they match, get the
	** next token.
	**
	** parameter:
	**	pI.....input file stream
	**	token..expected token
	**
	** Returns:Next token, or -1 on error
	********************************************/
	int rV;

	if(token == m_LookAHead)
		rV = Lexer(pI);
	else
	{
		char *s = new char[256];
		sprintf(s,"Expected %d  Got %d",token,m_LookAHead);
		Error(s);
		rV = -1;
		delete[] s;
	}
	return rV;
}

int CRiskEditView::GetChar(FILE *pI)
{
	/************************************************
	** GetChar
	**
	** This function is used to get a
	** Character form the map
	** file that is being loaded.
	**
	** parameter:
	**	pI.....pointer to input file stream
	**
	**	RETURNS:next character from input stream
	**********************************************/
	int rv;

	if(m_Unget_Buffer)
	{
		rv = m_Unget_Buffer;
		m_Unget_Buffer = 0;
	}
	else
	{
		rv = fgetc(pI);
	}
	return rv;
}


void CRiskEditView::Error(char *em)
{
	/**************************************
	** Error
	**
	** This function displays an
	** Error message from the input
	** file parser.
	**
	** parameter:
	**	s.....String to display in message
	****************************************/
	char *s = new char[256];
	sprintf(s,"%s:Line %d",em,m_Line);
	MessageBox(s,"ERROR",MB_ICONHAND);
	delete [] s;
}


void CRiskEditView::OnEditContinent()
{
	// TODO: Add your command handler code here
	/**************************************
	** OnEditContinent
	**
	** This function brings up the Dial.og
	** Box so that one can edit continent
	** properties, such as name, value, and
	** territories
	**************************************/
	CEditContinents *pDLG = new CEditContinents;
	pDLG->m_pMap = GetDocument()->m_pMapData;
	pDLG->DoModal();
	m_EraseBKG = 1;
	Invalidate();
}

void CRiskEditView::OnEditMeridians()
{
	// TODO: Add your command handler code here
	/************************************
	** OnEditMeridians
	**	This function does two
	** thngs.  First, it displays a dialog
	** box showing the current parameters
	** for drawing meridians and
	** Lattitudes (soory, I call them longgitudes, I
	** was a bit confused at the time)
	** on the map.
	** It then draws them on the map
	**
	************************************/
	CMap *pM;
	CDlgMeridianLogitude pDLG;
	CRiskEditDoc *pDoc = GetDocument();
	pDLG.m_pMap = pDoc->m_pMapData;
	pM = pDLG.m_pMap;
	int Id = pDLG.DoModal();
	if(Id == IDOK)
	{
		//------------------------
		//OK Draw Meridians
		//------------------------
		char *s = new char[256];

		CBrush Br;
		Br.CreateSolidBrush(RGB(255,255,255));
		CRect *pRec = new CRect(0,0,3600,2250);
		m_MemDC.FillRect(pRec,&Br);
		delete[] pRec;
		//----------------------------
		// Draw Meridians
		//----------------------------
		int span = pM->GetMerStart() - pM->GetMerEnd();	//span
		if(span < 0) span = -span;
		int count = span / pM->GetMerSpacing();
		int pixels = (3600) / count;
		int rem = (3600) % count;

		CPen Pen,*pP;
		Pen.CreatePen(PS_SOLID,pM->GetMerLineWidth(),RGB(0,0,0));
		int i;
		int MerStart=0;
		pP = m_MemDC.SelectObject(&Pen);
		//-----------------------------
		// For Labling Meridians
		//-----------------------------
		CFont mfont;
		mfont.CreateFont(10,7,-900,0,400,0,0,0,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"ARIAL");
		m_MemDC.SelectObject(&mfont);
		int Mer = pM->GetMerStart();
		for(i=0;i<count;++i)
		{
			sprintf(s,"%d",abs(Mer));
			Mer += pM->GetMerSpacing();
			m_MemDC.TextOut(MerStart+12,25,CString(s));
			m_MemDC.MoveTo(MerStart,0);
			m_MemDC.LineTo(MerStart,2249);
			MerStart += pixels;
			if(rem)
			{
				rem--;
				MerStart++;
			}
		}
		sprintf(s,"%d",abs(Mer));
		m_MemDC.TextOut(MerStart-2,25,CString(s));
		//----------------------------
		// Draw Longitude
		//----------------------------
		span = pM->GetLogStart() - pM->GetLogEnd();	//span
		if(span < 0) span = -span;
		count = span / pM->GetLogSpacing();
		pixels = (2250) / count;
		rem = (2250) % count;
		//-----------------------------
		// For Labling Longitude
		//-----------------------------
		CFont Lfont;
		Lfont.CreatePointFont(100,"ARIAL");
		m_MemDC.SelectObject(&Lfont);
		int Log = pM->GetLogStart();
		MerStart=0;
		for(i=0;i<count;++i)
		{
			sprintf(s,"%d",abs(Log));
			Log -= pM->GetLogSpacing();
			m_MemDC.TextOut(25,MerStart,CString(s));
			m_MemDC.MoveTo(0,MerStart);
			m_MemDC.LineTo(3599,MerStart);
			MerStart += pixels;
			if(rem)
			{
				rem--;
				MerStart++;
			}
		}
		m_MemDC.SelectObject(pP);

		Invalidate();
		delete[] s;
	}
}

void CRiskEditView::OnEditDebug()
{
	// TODO: Add your command handler code here
	char *s = new char[256];
	sprintf(s,"LastPoint X=%d  Y=%d",m_LastPoint.x,m_LastPoint.y);
	MessageBox(s,"DEBUG");
	delete[] s;
}

void CRiskEditView::OnEditColor()
{
	/**********************************
	** Message Handler OnEditColor
	**
	** This function opens a dialog box
	** so that you can change the draw
	** color.
	**********************************/
	// TODO: Add your command handler code here
	CColorDialog Dlg(m_CurColor,CC_FULLOPEN);


	Dlg.DoModal();
	m_CurColor = Dlg.GetColor();

}

void CRiskEditView::OnDrawTool()
{
	/*********************************
	** Message Handler OnDrawTool
	**
	** This function puts the Editor
	** into the General Purpose Draw
	** mode
	*********************************/
	// TODO: Add your command handler code here
	this->m_CurTool = TOOL_DRAW;
	EnableAutoScrolling(FALSE);
}

void CRiskEditView::OnFillTool()
{
	/**********************************
	** Message Handler OnFillTool
	**
	** This function is used to put
	** the editor into the Fill Mode
	**********************************/
	// TODO: Add your command handler code here
	this->m_CurTool = TOOL_FILL;
	EnableAutoScrolling(FALSE);
}

void CRiskEditView::OnErase()
{
	/********************************
	** Message Handler OnErase
	**
	** This function puts the Editor
	** into the Erase Mode
	********************************/
	// TODO: Add your command handler code here
	this->m_CurTool = TOOL_ERASE;;
	EnableAutoScrolling(FALSE);
}

void CRiskEditView::OnBordersTool()
{
	/*********************************
	** Message Handler OnBordersTool
	**
	** This function sets the drawing
	** mode into Drawing Borders Mode
	*********************************/
	// TODO: Add your command handler code here
	this->m_CurTool = TOOL_BORDER;
	EnableAutoScrolling(FALSE);

}


void CRiskEditView::OnButtonPolygon()
{
	/*********************************
	** Message Handler OnButtonPolygon
	**
	**  This function puts the drawing
	** mode into the Draw Polygon mode.
	*********************************/
	// TODO: Add your command handler code here
	m_CurTool = TOOL_POLYGON;
	m_PolyState = 0;
	this->m_scrPoly.SetSelected(1);
	EnableAutoScrolling(TRUE);
//	EnableAutoScrolling(FALSE);
}

void CRiskEditView::DrawPolyLine(CDC *pDC, CPolygon *pP)
{
	int i,c;
	CPoint *pPA;
	int sel;
	c = pP->GetCount();
	CPen PenSel;
	CPen *pOld;
	pPA = pP->GetPoints();
	if(sel = pP->GetSelected())
	{
		if(sel == 1) PenSel.CreatePen(PS_SOLID,3,RGB(255,0,0));
		else if(sel == 2) PenSel.CreatePen(PS_SOLID,3,RGB(255,0,255));
		pOld = pDC->SelectObject(&PenSel);
	}
	for(i=0;i<c;++i)
	{
		if(i+1 == c)
		{
		}
		else
		{
			pDC->MoveTo(pPA[i]);
			pDC->LineTo(pPA[i+1]);
		}
	}
	if(pP->GetSelected())
	{
		pDC->SelectObject(pOld);
	}
}

void CRiskEditView::DrawPoly(CDC *pDC, CPolygon *pP)
{
	/********************************
	** DrawPoly
	**
	** This function is used to draw
	** a polygon.  It is a replacement
	** for the one built into windows.
	**
	** parameters:
	**	pDC.....pointer to the device context
	**	pP......pointer to the polygon to draw
	**
	********************************/
	int i,c;
	CPoint *pPA;
	c = pP->GetCount();
	CPen PenSel;
	CPen *pOld;
	int sel;
	pPA = pP->GetPoints();
	if(sel = pP->GetSelected())
	{
		if(sel == 1)PenSel.CreatePen(PS_SOLID,3,RGB(255,0,0));
		else if(sel == 2)PenSel.CreatePen(PS_SOLID,3,RGB(255,0,255));
		pOld = pDC->SelectObject(&PenSel);
	}
	for(i=0;i<c;++i)
	{
		if(i+1 == c)
		{
			pDC->MoveTo(pPA[i]);
			pDC->LineTo(pPA[0]);
		}
		else
		{
			pDC->MoveTo(pPA[i]);
			pDC->LineTo(pPA[i+1]);
		}
	}
	if(pP->GetSelected())
	{
		pDC->SelectObject(pOld);
	}

}

void CRiskEditView::OnTimer(UINT nIDEvent)
{
	/**********************************
	** Message Handler OnTimer
	**
	** parameter:
	**	nIDEvent....this is the ID of
	**              the timer event
	**              that caused this
	**              message to be
	**              generated.
	**
	** This function handles timer
	** messages.  They are primarily
	** used to debounce mouse button
	** click messages.
	**********************************/
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent)
	{
		case TIMEREVENT_LMB:
			this->m_Timer_MB_LeftFlag = 0;
			break;
		case TIMEREVENT_RMB:
			this->m_Timer_MB_RightFlag = 0;
			break;
		case TIMEREVENT_SCROLL:
			m_TimerScroll = 1;
			break;
	}
	CAutoScrollView::OnTimer(nIDEvent);
}

void CRiskEditView::OnViewPolygons()
{
	/****************************************
	** Message Handler OnViewPolygons
	**
	** This function is used to turn
	** on and off the veiwing of the
	** polygons on the display.
	****************************************/
	// TODO: Add your command handler code here
	CMainFrame *pMF = (CMainFrame *)this->GetParentFrame();
	CMenu *pM = pMF->GetMenu();
	UINT state = pM->GetMenuState(IDM_VIEW_POLYGONS,MF_BYCOMMAND);
	if(MF_CHECKED & state)
	{
		pM->CheckMenuItem(IDM_VIEW_POLYGONS,0);
		m_PolyView = 0;
	}
	else
	{
		pM->CheckMenuItem(IDM_VIEW_POLYGONS,MF_CHECKED);
		m_PolyView = 1;
	}
	Invalidate();
}

void CRiskEditView::OnButtonAssign()
{
	/**********************************
	** Message Handler OnButtonAssign
	**
	** This function is used to connect
	** a polygon to a specific territory.
	**********************************/
	// TODO: Add your command handler code here
		m_CurTool = TOOL_ASSING;
	EnableAutoScrolling(FALSE);

}

void CRiskEditView::OnButtonConnect()
{
	/******************************
	** OnButtonConnect
	**
	** Open the dialog to edit
	** connections between territories
	******************************/
	// TODO: Add your command handler code here
	m_CurTool = TOOL_CONNECT;
	CEditAdjacetTerr Dlg;
	CRiskEditDoc *pDoc = GetDocument();

	Dlg.m_pMap = pDoc->m_pMapData;
	Dlg.DoModal();

}

CMapTerritory * CRiskEditView::FindTerritory(CMap *pM,char *s)
{
	/***********************************
	** FindTerritory
	**	This function finds a specific
	** territory in the map by name.
	**
	** parameters:
	**	pM.....pointer to the map to search
	**	s......name of territory to find
	**
	** RETURNS:pointer to territory on success
			  :NULL on fail
	***********************************/
	CMapContinent *pC = (CMapContinent *)pM->GetChild();
	CMapTerritory *pT;
	int loop = 1;
	//--------------------------
	// search entire data base
	// for the territory name
	//--------------------------
	while(pC && loop)
	{
		pT = (CMapTerritory *)pC->GetChild();
		while(pT && loop)
		{
			if(strcmp(s,pT->GetName()) ==0 )
				loop = 0;
			else
				pT = (CMapTerritory *)pT->GetNext();
		}
		pC = (CMapContinent *)pC->GetNext();
	}
	if(loop) pT = NULL;	//didn't find it
	return pT;
}

int CRiskEditView::Compile(CMap *pMap)
{
	/**************************************
	**Compile
	**
	** This function is used to complet the
	** loading of a .map file.  If territories
	** have adjacent territories, it is
	** possible to have a territory in a
	** neighbor list that has not actually
	** been loaded yet.  So, we just load the
	** name.  Now we locate the matching
	** CMapTerritory * objects that match up
	** to the names.
	**
	** parameters:
	**	pMap....pointer to the map to compile.
	**************************************/
	CMapContinent *pMC = (CMapContinent *)pMap->GetChild();
	CMapTerritory *pMT,*pTn;
	CTerrList *pL;

	while(pMC)
	{
		pMT = (CMapTerritory *)pMC->GetChild();
		while(pMT)
		{
			if((pL = pMT->GetNieghborList()) != NULL)
			{
				while(pL)
				{
					pTn = FindTerritory(pMap,pL->GetName());
					pL->SetTerr(pTn);
					pL = pL->GetNext();
				}
			}
			pMT = (CMapTerritory *)pMT->GetNext();
		}
		pMC = (CMapContinent *)pMC->GetNext();
	}
	return 0;
}

void CRiskEditView::OnLargedot()
{
	// TODO: Add your command handler code here
	m_DrawPenSize = 15;
}

void CRiskEditView::OnMediumdot()
{
	// TODO: Add your command handler code here
	m_DrawPenSize = 6;
}

void CRiskEditView::OnSmalldot()
{
	// TODO: Add your command handler code here
	m_DrawPenSize = 1;
}

/********************************************
** OnUpdateOneGetcolor <Message Handler>
**
**
********************************************/
void CRiskEditView::OnUpdateOneGetcolor(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable();
}

/************************************************
** OnUpdateOneDelPoly <Message Handler>
**
** This function is called to determine if the
** menu item "DELETE POLYGON" in the context
** menu needs to be enabled or not.
************************************************/
void CRiskEditView::OnUpdateOneDelPoly(CCmdUI* pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable();

}

/***********************************************
** OnUpdateOneAssign  <Message Handler>
**
** This function is called to determine if
**	the menu item "ASSIGN TERRITORY" in the
** context menu should be enabled or not.
**
***********************************************/
void CRiskEditView::OnUpdateOneAssign(CCmdUI* pCmdUI)
{
	pCmdUI->Enable();

}

/******************************************
** AssignTerrToPoly
**		This function is used to assign a
**	territory to a polygon.  It will first
** check to find out if there is a polygon
** under the point of interest, and if so
** will have the user select the territory
**
** parameters:
**	pos......point that will end up being
**           The location of the territory
**           This point must be contained
**           by a polygon, that is hopefully
**           about the same shape.
**
** Return Value: Returns 0 on fail,
**                       1 on success
******************************************/
int CRiskEditView::AssignTerrToPoly(CPoint pos)
{
	int rV = 0,id;
	CRiskEditDoc *pDoc;
	CPolygon *pPol;
	CMapTerritory *pT;

	pDoc = GetDocument();
	pPol = pDoc->m_pPolyList;
	while(pPol && !rV)
	{

		if(pPol->PointEnclosed(pos))
			rV = 1;
		else
			pPol = pPol->GetNext();
	}
	if(rV)
	{
		pPol->SetSelected(2);
		CSelectTerritory Dlg;
		Dlg.m_pMap = pDoc->m_pMapData;
		Dlg.m_pSelTerr = pPol->GetTerritory();
		id = Dlg.DoModal();
		if(id == IDOK)
		{
			pT = Dlg.m_pSelTerr;
			pPol->SetTerritory(pT);
			pT->SetLocation(pos.x,pos.y);
		}
	}
	return rV;
}

void CRiskEditView::OnUpdateOneLinkTerr(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable();
}

void CRiskEditView::OnCancelMode() 
{
	CAutoScrollView::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}

void CRiskEditView::OnMenuViewAutoscroll() 
{
	// TODO: Add your command handler code here
	CMainFrame *pMF = (CMainFrame *)this->GetParentFrame();
	CMenu *pM = pMF->GetMenu();
	UINT state = pM->GetMenuState(ID_MENU_VIEW_AUTOSCROLL,MF_BYCOMMAND);
	if(MF_CHECKED & state)
	{
		pM->CheckMenuItem(ID_MENU_VIEW_AUTOSCROLL,0);
		m_AutoScrollMode = 0;
		EnableScrollBarCtrl(SB_BOTH,TRUE);
	}
	else
	{
		pM->CheckMenuItem(ID_MENU_VIEW_AUTOSCROLL,MF_CHECKED);
		m_AutoScrollMode = 1;
		EnableScrollBarCtrl(SB_BOTH,FALSE);
	}
	Invalidate();
}

void CRiskEditView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CAutoScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CRiskEditView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CAutoScrollView::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CRiskEditView::OnSize(UINT nType, int cx, int cy) 
{
	if(m_AutoScrollMode == 0)
		CAutoScrollView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
}

void CRiskEditView::OnAutoScroll(CPoint point, BOOL bBeforeScroll)
{
	if(bBeforeScroll)
	{
		switch(this->m_CurTool)
		{
			case TOOL_DRAW:
				break;
			case TOOL_FILL:
				break;
			case TOOL_ERASE:
				break;
			case TOOL_BORDER:
				break;
			case TOOL_POLYGON:
				break;
			case TOOL_ASSING:
				break;
		}
	}
	else
	{
		switch(this->m_CurTool)
		{
			case TOOL_DRAW:
				break;
			case TOOL_FILL:
				break;
			case TOOL_ERASE:
				break;
			case TOOL_BORDER:
				break;
			case TOOL_POLYGON:
				break;
			case TOOL_ASSING:
				break;
		}
	}
}

void CRiskEditView::OnMenuInfoStats() 
{
	// TODO: Add your command handler code here
	CMapInfoDialog nDlg;
	CRiskEditDoc *pDoc = this->GetDocument();
	nDlg.pMap = pDoc->m_pMapData;

	nDlg.DoModal();
}

void CRiskEditView::OnMenuEditUdatecolors() 
{
	// TODO: Add your command handler code here
	CRiskEditDoc *pDoc = this->GetDocument();
	CMap *pM = pDoc->m_pMapData;
	CMapContinent *pC = (CMapContinent *)pM->GetChild();
	CMapTerritory *pT;
	int x,y;

	while(pC)
	{
		pT = (CMapTerritory *)pC->GetChild();
		while(pT)
		{
			pT->GetLocation(&x,&y);
			pT->SetColor(m_MemDC.GetPixel(x,y));
			pT = (CMapTerritory *)pT->GetNext();
		}
		pC = (CMapContinent *)pC->GetNext();
	}
}
