// SelectTerritory.cpp : implementation file
//

#include "stdafx.h"
#include "riskedit.h"
#include "SelectTerritory.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectTerritory dialog


CSelectTerritory::CSelectTerritory(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectTerritory::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectTerritory)
	//}}AFX_DATA_INIT
}


void CSelectTerritory::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectTerritory)
	DDX_Control(pDX, IDC_LIST_SELTERR_TERRITORY, m_List_Territory);
	DDX_Control(pDX, IDC_LIST_SELTERR_CONTINENT, m_List_Continent);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectTerritory, CDialog)
	//{{AFX_MSG_MAP(CSelectTerritory)
	ON_LBN_DBLCLK(IDC_LIST_SELTERR_CONTINENT, OnDblclkListSelterrContinent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectTerritory message handlers

BOOL CSelectTerritory::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	CMapContinent *pC;

	pC = (CMapContinent *)m_pMap->GetChild();
	while(pC)
	{
		m_List_Continent.AddString(pC->GetName());
		pC = (CMapContinent *)pC->GetNext();
	}
	if(m_pSelTerr)	//territory allready selected
	{
		CMapContinent *pCSel;
		pCSel = m_pMap->FindContinent(this->m_pSelTerr);
		ClearListBox(&m_List_Territory);
		CMapTerritory *pT = (CMapTerritory *)pCSel->GetChild();
		while(pT)
		{
			m_List_Territory.AddString(pT->GetName());
			pT = (CMapTerritory *)pT->GetNext();
		}
		m_List_Territory.SelectString(0,m_pSelTerr->GetName());
		m_List_Continent.SelectString(0,pCSel->GetName());
		m_pSelCont = pCSel;

	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectTerritory::OnDblclkListSelterrContinent()
{
	/***********************************
	** Message Handler OnDblclkListSelterrContinent
	**
	**	This function is used to select
	** the continent that contains the
	** territory that we are interested in
	**
	***********************************/
	// TODO: Add your control notification handler code here
	int sel;
	char *s = new char[256];
	CMapContinent *pC;
	CMapTerritory *pT;
	ClearListBox(&m_List_Territory);

	sel = m_List_Continent.GetCurSel();
	m_List_Continent.GetText(sel,s);
	pC = (CMapContinent *)m_pMap->GetChild();
	pC = FindContinent(s,pC);
	pT = (CMapTerritory *)pC->GetChild();
	while(pT)
	{
		m_List_Territory.AddString(pT->GetName());
		pT = (CMapTerritory *)pT->GetNext();
	}
	m_pSelCont = pC;
	delete[] s;
}

CMapContinent * CSelectTerritory::FindContinent(char *s, CMapContinent *pMC)
{
	/************************************
	** FindContinent
	**
	** This function locates and returns
	** a pointer to a specific continent from
	** a list of continents
	**
	** parameters:
	**	s......name of continent to search for
	** 	pMC....pointer to list of continents
	**
	** Returns:NULL if not found, pointer
	** to continent otherwise.
	******************************************/
	int loop = 1;
	///loop until we find it or run out of data
	while(pMC && loop)
	{
		if(strcmp(s,pMC->GetName()) == 0) loop = 0;
		else
			pMC = (CMapContinent *)pMC->GetNext();
	}
	return pMC;
}

void CSelectTerritory::ClearListBox(CListBox *pLB)
{
	/*****************************************
	** ClearListBox
	**
	** This function is used to clear all of
	** the entries out of a list box.
	**
	** parameter:
	**	pLB.......pointer to the list box to clear
	*****************************************/
	int i;
	int n = pLB->GetCount();
	if(n)
	{
		for(i=0;i<n;++i)
			pLB->DeleteString(n-i-1);
	}
}

CMapTerritory * CSelectTerritory::FindTerritory(char *s, CMapTerritory *pMT)
{
	/****************************************
	** FindTeritory
	**
	** This function is used to find
	** a specific territory that is in the
	** list of territories for this
	** continent
	**
	**	parameter:
	**	s......name of territory to find
	**
	** Returns: NULL if not found
	**          Pointer to territory otherwise
	******************************************/
	int loop = 1;
	while(pMT && loop)
	{
		if(strcmp(s,pMT->GetName()) == 0)
			loop = 0;
		else
			pMT = (CMapTerritory *)pMT->GetNext();
	}
	return pMT;
}

void CSelectTerritory::OnOK() 
{
	// TODO: Add extra validation here
	CMapTerritory *pT;
	char *s = new char[256];

	int sel = m_List_Territory.GetCurSel();
	if(sel < 0)
		MessageBox("Select A Territory","Hey YOU!",MB_OK);
	else
	{
		m_List_Territory.GetText(sel,s);
		pT = (CMapTerritory *)m_pSelCont->GetChild();
		m_pSelTerr = FindTerritory(s,pT);
		delete[] s;
		
		CDialog::OnOK();
	}
}
